Subject: Re: net-next: lockdep complains re percpu counters

From: Eric Dumazet <[email-masked]>
Date: Tue, 02 Dec 2008 09:29:22 +0100

David Miller a écrit :
> From: Eric Dumazet <[email-masked]>
> Date: Sun, 30 Nov 2008 17:36:56 +0100
> 
>> [PATCH] net: percpu_counter_inc() should not be called in BH-disabled section
>>
>> I checked all per_cpu_counter_xxx() usages in network tree, and I think
>> all call sites are BH enabled except one in inet_csk_listen_stop().
>>
>> commit dd24c00191d5e4a1ae896aafe33c6b8095ab4bd1
>> (net: Use a percpu_counter for orphan_count)
>> replaced atomic_t orphan_count to a percpu_counter.
>>
>> atomic_inc()/atomic_dec() can be called from any context, while percpu_counter_xxx()
>> should be called from a consistent state.
>>
>> For orphan_count, this context can be the BH-enabled one.
>>
>> Signed-off-by: Eric Dumazet <[email-masked]>
> 
> I applied this preemptively even though Alexey hasn't given
> test feedback yet, and I also added a mention of his report
> in the commit message.

Hum, this patch was necessary but wont help Alexy case that was
not related, if I undertsnad well its oops.

Its oops was about nr_files and a network percpu_counter, one
always called in BH-enabled context, one always in BD-disabled context.

We need a core change here, so that lockdep dont assume all percpu_counter
have the same class.

I know nothing about lockdep so a fix could take me some time, one
can beat me easily ;)